<template>
  <rui-navbar>
    <template #left>
      <rui-navbar-menu>
        <router-link to="/" class="rui-menu-item">
          <strong>{{ $project.name }}</strong>
          <rui-badge v-if="$project.version" size="small" class="-text--monospace">v{{ $project.version }}</rui-badge>
        </router-link>
      </rui-navbar-menu>
    </template>

    <template #right>
      <rui-navbar-menu right>
        <rui-menu-item v-if="$project.repositoryUrl" :href="$project.repositoryUrl" target="_blank" icon="doc:external-link">Repository</rui-menu-item>
      </rui-navbar-menu>

      <rui-navbar-menu right toolbar>
        <rui-toolbar label="Theme" class="-mrd">
          <rui-button caption="browser" :active="theme === null" @click="theme = null" />
          <rui-button caption="dark" :active="theme === 'dark'" @click="theme = 'dark'" />
          <rui-button caption="light" :active="theme === 'light'" @click="theme = 'light'" />
          <template #help>
            <h2 class="-mt0">Note on themes</h2>
            <p>Examples won't automatically change.</p>
            <p>To update them, either <em>reload</em> or <em>change page</em> and come back.</p>
          </template>
        </rui-toolbar>
      </rui-navbar-menu>
    </template>
  </rui-navbar>
</template>

<script>
import { RuiBadge, RuiButton, RuiMenuItem, RuiNavbar, RuiNavbarMenu, RuiToolbar } from '../../../src/components'

export default {
  name: 'DocAppNavbar',
  components: { RuiButton, RuiNavbar, RuiNavbarMenu, RuiBadge, RuiMenuItem, RuiToolbar },
  data () {
    return {
      componentFilter: '',
      theme: this.$storage.theme,
    }
  },
  methods: {
    toggleTheme (value) {
      this.$storage.theme = value

      switch (value) {
        case 'dark':
          document.body.classList.remove('rui-theme--light')
          document.body.classList.add('rui-theme--dark')
          break
        case 'light':
          document.body.classList.add('rui-theme--light')
          document.body.classList.remove('rui-theme--dark')
          break
        default:
          document.body.classList.remove('rui-theme--light', 'rui-theme--dark')
      }
    },
  },
  created () {
    const theme = this.$storage.theme
    if (theme) this.toggleTheme(theme)
  },
  watch: {
    theme (newValue, oldValue) {
      if (newValue === oldValue) return

      this.toggleTheme(newValue)
    },
  },
}
</script>
